LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.NUMERIC_STD.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY conta_ad IS
	PORT(AD, CLK_MST: IN STD_LOGIC;
              COUNT: BUFFER INTEGER RANGE 0 TO 7;
		          SEG: OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		          DIG: OUT STD_LOGIC);
END ENTITY;

ARCHITECTURE BEAS OF conta_ad IS
SIGNAL FREC: INTEGER := 24999999;
SIGNAL AUX: INTEGER RANGE 0 TO FREC;
SIGNAL CLK: STD_LOGIC;
BEGIN

	PROCESS(CLK_MST)
	BEGIN 
		IF RISING_EDGE (CLK_MST) THEN
			IF AUX = 0 THEN  -- IF AUX = FREC THEN
				CLK <= NOT CLK;
				AUX <= FREC; -- AUX <= 0;
			ELSE
				AUX <= AUX - 1; -- AUX <= AUX + 1;
			END IF;
		END IF;
	END PROCESS;

	PROCESS(CLK, AD)
	BEGIN
		IF RISING_EDGE(CLK) THEN
			IF AD = '1' THEN -- Ascendente
				IF COUNT = 0 THEN
					COUNT <= 7;
				ELSE
					COUNT <= COUNT - 1;
				END IF;
			ELSE -- Descendente
				IF COUNT = 7 THEN
					COUNT <= 0;
				ELSE
					COUNT <= COUNT + 1;
				END IF;
			END IF;
		END IF;
	END PROCESS;
	
	DIG <= '0';
	
	WITH COUNT SELECT
		  SEG <= "00000011" WHEN 0, -- 0
					"10011111" WHEN 1, -- 1
					"00100101" WHEN 2, -- 2
					"00001101" WHEN 3, -- 3
					"10011001" WHEN 4, -- 4
					"01001001" WHEN 5, -- 5
					"01000001" WHEN 6, -- 6
					"00011111" WHEN 7, -- 7
					"11111111" WHEN OTHERS;
	
END BEAS;